function [x_estimate, P_estimate]  = update_ekf(y, x_predict, P_predict, h, J_h, R)
  
  B = J_h(x_predict);
  
  P_estimate = inv(inv(P_predict) + B'*(R\B));
  x_estimate = x_predict  + P_estimate*B'*(R\(y-h(x_predict)));
  
end