function [diff, ceq] = constraints(X, f)
    
    [nx, N] = size(X);
    
    diff = zeros(nx, N-1);
    
    for k=1:N-1
        x_current = X(:, k);
        x_next = X(:, k+1);
        w = x_next - f(x_current);
        diff(:, k) = -w;
    end
    
    diff = reshape(diff, nx*(N-1), 1);
    
    ceq=[];

end